org.codehaus.plexus.util.xml.pull

## Interface XmlSerializer

All Known Implementing Classes:
  MXSerializer

    public interface XmlSerializer

Define an interface to serialization of XML Infoset. This interface abstracts away if serialized XML is XML 1.0 compatible text or other formats of XML 1.0 serializations (such as binary XML for example with WBXML).

PLEASE NOTE: This interface will be part of XmlPull 1.2 API. It is included as basis for discussion. It may change in any way.

Exceptions that may be thrown are: IOException or runtime exception (more runtime exceptions can be thrown but are not declared and as such have no semantics defined for this interface):

- IllegalArgumentException - for almost all methods to signal that argument is illegal
- IllegalStateException - to signal that call has good arguments but is not expected here (violation of contract) and for features/properties when requesting setting unimplemented feature/property (UnsupportedOperationException would be better but it is not in MIDP)

NOTE: writing CDSECT, ENTITY_REF, IGNORABLE_WHITESPACE, PROCESSING_INSTRUCTION, COMMENT, and DOCDECL in some implementations may not be supported (for example when serializing to WBXML). In such case IllegalStateException will be thrown and it is recommended to use an optional feature to signal that implementation is not supporting this kind of output.

### Method Summary

All Methods Instance Methods Abstract Methods
`XmlSerializer` `attribute(java.lang.String namespace, java.lang.String name, java.lang.String value)` Write an attribute.
`void` `cdsect(java.lang.String text)`
`void` `comment(java.lang.String text)`
`void` `docdecl(java.lang.String text)`
`void` `endDocument()` Finish writing.
`XmlSerializer` `endTag(java.lang.String namespace, java.lang.String name)` Write end tag.
`void` `entityRef(java.lang.String text)`
`void` `flush()` Write all pending output to the stream.
`int` `getDepth()` Returns the current depth of the element.
`boolean` `getFeature(java.lang.String name)` Return the current value of the feature with given name.
`java.lang.String` `getName()` Returns the name of the current element as set by startTag().
`java.lang.String` `getNamespace()` Returns the namespace URI of the current element as set by startTag().
`java.lang.String` `getPrefix(java.lang.String namespace, boolean generatePrefix)` Return namespace that corresponds to given prefix If there is no prefix bound to this namespace return null but if generatePrefix is false then return generated prefix.
`java.lang.Object` `getProperty(java.lang.String name)` Look up the value of a property.
`void` `ignorableWhitespace(java.lang.String text)`
`void` `processingInstruction(java.lang.String text)`
`void` `setFeature(java.lang.String name, boolean state)` Set feature identified by name (recommended to be URI for uniqueness).
`void` `setOutput(java.io.OutputStream os, java.lang.String encoding)` Set to use binary output stream with given encoding.
`void` `setOutput(java.io.Writer writer)` Set the output to the given writer.
`void` `setPrefix(java.lang.String prefix, java.lang.String namespace)` Binds the given prefix to the given namespace.
`void` `setProperty(java.lang.String name, java.lang.Object value)` Set the value of a property.
`void` `startDocument(java.lang.String encoding, java.lang.Boolean standalone)` Write <?xml declaration with encoding (if encoding not null) and standalone flag (if standalone not null) This method can only be called just after setOutput.
`XmlSerializer` `startTag(java.lang.String namespace, java.lang.String name)` Writes a start tag with the given namespace and name.
`XmlSerializer` `text(char[] buf, int start, int len)` Writes text, where special XML chars are escaped automatically
`XmlSerializer` `text(java.lang.String text)` Writes text, where special XML chars are escaped automatically

### Method Detail

#### setFeature

    void setFeature(java.lang.String name,
                    boolean state)
             throws java.lang.IllegalArgumentException,
                    java.lang.IllegalStateException

Set feature identified by name (recommended to be URI for uniqueness). Some well known optional features are defined in http://www.xmlpull.org/v1/doc/features.html. If feature is not recognized or can not be set then IllegalStateException MUST be thrown.

Throws:
  `java.lang.IllegalStateException` - If the feature is not supported or can not be set
  `java.lang.IllegalArgumentException`

#### getFeature

    boolean getFeature(java.lang.String name)

Return the current value of the feature with given name.

NOTE: unknown properties are always returned as null

Parameters:
  `name` - The name of feature to be retrieved.
Returns:
  The value of named feature.
Throws:
  `java.lang.IllegalArgumentException` - if feature string is null

#### setProperty

    void setProperty(java.lang.String name,
                     java.lang.Object value)
              throws java.lang.IllegalArgumentException,
                     java.lang.IllegalStateException

Set the value of a property. (the property name is recommended to be URI for uniqueness). Some well known optional properties are defined in http://www.xmlpull.org/v1/doc/properties.html. If property is not recognized or can not be set then IllegalStateException MUST be thrown.

Throws:
  `java.lang.IllegalStateException` - if the property is not supported or can not be set
  `java.lang.IllegalArgumentException`

#### getProperty

    java.lang.Object getProperty(java.lang.String name)

Look up the value of a property. The property name is any fully-qualified URI. I

NOTE: unknown properties are <string>always returned as null

Parameters:
  `name` - The name of property to be retrieved.
Returns:
  The value of named property.

#### setOutput

    void setOutput(java.io.OutputStream os,
                   java.lang.String encoding)
            throws java.io.IOException,
                   java.lang.IllegalArgumentException,
                   java.lang.IllegalStateException

Set to use binary output stream with given encoding.

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### setOutput

    void setOutput(java.io.Writer writer)
            throws java.io.IOException,
                   java.lang.IllegalArgumentException,
                   java.lang.IllegalStateException

Set the output to the given writer.

WARNING no information about encoding is available!

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### startDocument

    void startDocument(java.lang.String encoding,
                       java.lang.Boolean standalone)
                throws java.io.IOException,
                       java.lang.IllegalArgumentException,
                       java.lang.IllegalStateException

Write <?xml declaration with encoding (if encoding not null) and standalone flag (if standalone not null) This method can only be called just after setOutput.

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### endDocument

    void endDocument()
              throws java.io.IOException,
                     java.lang.IllegalArgumentException,
                     java.lang.IllegalStateException

Finish writing. All unclosed start tags will be closed and output will be flushed. After calling this method no more output can be serialized until next call to setOutput()

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### setPrefix

    void setPrefix(java.lang.String prefix,
                   java.lang.String namespace)
            throws java.io.IOException,
                   java.lang.IllegalArgumentException,
                   java.lang.IllegalStateException

Binds the given prefix to the given namespace. This call is valid for the next element including child elements. The prefix and namespace MUST be always declared even if prefix is not used in element (startTag() or attribute()) - for XML 1.0 it must result in declaring `xmlns:prefix='namespace'` (or `xmlns:prefix="namespace"` depending what character is used to quote attribute value).

NOTE: this method MUST be called directly before startTag() and if anything but startTag() or setPrefix() is called next there will be exception.

NOTE: prefixes "xml" and "xmlns" are already bound and can not be redefined see: Namespaces in XML Errata.

NOTE: to set default namespace use as prefix empty string.

Parameters:
  `prefix` - must be not null (or IllegalArgumentException is thrown)
  `namespace` - must be not null
Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### getPrefix

    java.lang.String getPrefix(java.lang.String namespace,
                               boolean generatePrefix)
                        throws java.lang.IllegalArgumentException

Return namespace that corresponds to given prefix If there is no prefix bound to this namespace return null but if generatePrefix is false then return generated prefix.

NOTE: if the prefix is empty string "" and default namespace is bound to this prefix then empty string ("") is returned.

NOTE: prefixes "xml" and "xmlns" are already bound will have values as defined Namespaces in XML specification

Throws:
  `java.lang.IllegalArgumentException`

#### getDepth

    int getDepth()

Returns the current depth of the element. Outside the root element, the depth is 0. The depth is incremented by 1 when startTag() is called. The depth is decremented after the call to endTag() event was observed.

     <!-- outside -->     0
     <root>               1
       sometext                 1
         <foobar>         2
         </foobar>        2
     </root>              1
     <!-- outside -->     0

#### getNamespace

    java.lang.String getNamespace()

Returns the namespace URI of the current element as set by startTag().

NOTE: that means in particular that:

- if there was startTag("", ...) then getNamespace() returns ""
- if there was startTag(null, ...) then getNamespace() returns null

Returns:
  namespace set by startTag() that is currently in scope

#### getName

    java.lang.String getName()

Returns the name of the current element as set by startTag(). It can only be null before first call to startTag() or when last endTag() is called to close first startTag().

Returns:
  namespace set by startTag() that is currently in scope

#### startTag

    XmlSerializer startTag(java.lang.String namespace,
                           java.lang.String name)
                    throws java.io.IOException,
                           java.lang.IllegalArgumentException,
                           java.lang.IllegalStateException

Writes a start tag with the given namespace and name. If there is no prefix defined for the given namespace, a prefix will be defined automatically. The explicit prefixes for namespaces can be established by calling setPrefix() immediately before this method. If namespace is null no namespace prefix is printed but just name. If namespace is empty string then serializer will make sure that default empty namespace is declared (in XML 1.0 xmlns='') or throw IllegalStateException if default namespace is already bound to non-empty string.

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### attribute

    XmlSerializer attribute(java.lang.String namespace,
                            java.lang.String name,
                            java.lang.String value)
                     throws java.io.IOException,
                            java.lang.IllegalArgumentException,
                            java.lang.IllegalStateException

Write an attribute. Calls to attribute() MUST follow a call to startTag() immediately. If there is no prefix defined for the given namespace, a prefix will be defined automatically. If namespace is null or empty string no namespace prefix is printed but just name.

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### endTag

    XmlSerializer endTag(java.lang.String namespace,
                         java.lang.String name)
                  throws java.io.IOException,
                         java.lang.IllegalArgumentException,
                         java.lang.IllegalStateException

Write end tag. Repetition of namespace and name is just for avoiding errors.

Background: in kXML endTag had no arguments, and non matching tags were very difficult to find... If namespace is null no namespace prefix is printed but just name. If namespace is empty string then serializer will make sure that default empty namespace is declared (in XML 1.0 xmlns='').

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### text

    XmlSerializer text(java.lang.String text)
                throws java.io.IOException,
                       java.lang.IllegalArgumentException,
                       java.lang.IllegalStateException

Writes text, where special XML chars are escaped automatically

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### text

    XmlSerializer text(char[] buf,
                       int start,
                       int len)
                throws java.io.IOException,
                       java.lang.IllegalArgumentException,
                       java.lang.IllegalStateException

Writes text, where special XML chars are escaped automatically

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### cdsect

    void cdsect(java.lang.String text)
         throws java.io.IOException,
                java.lang.IllegalArgumentException,
                java.lang.IllegalStateException

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### entityRef

    void entityRef(java.lang.String text)
            throws java.io.IOException,
                   java.lang.IllegalArgumentException,
                   java.lang.IllegalStateException

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### processingInstruction

    void processingInstruction(java.lang.String text)
                        throws java.io.IOException,
                               java.lang.IllegalArgumentException,
                               java.lang.IllegalStateException

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### comment

    void comment(java.lang.String text)
          throws java.io.IOException,
                 java.lang.IllegalArgumentException,
                 java.lang.IllegalStateException

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### docdecl

    void docdecl(java.lang.String text)
          throws java.io.IOException,
                 java.lang.IllegalArgumentException,
                 java.lang.IllegalStateException

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### ignorableWhitespace

    void ignorableWhitespace(java.lang.String text)
                      throws java.io.IOException,
                             java.lang.IllegalArgumentException,
                             java.lang.IllegalStateException

Throws:
  `java.io.IOException`
  `java.lang.IllegalArgumentException`
  `java.lang.IllegalStateException`

#### flush

    void flush()
        throws java.io.IOException

Write all pending output to the stream. If method startTag() or attribute() was called then start tag is closed (final >) before flush() is called on underlying output stream.

NOTE: if there is need to close start tag (so no more attribute() calls are allowed) but without flushing output call method text() with empty string (text("")).

Throws:
  `java.io.IOException`